#if defined _smokecolors_included
    #endinput
#endif
#define _smokecolors_included

/**
* Создаёт цветной дым.
*
* @param sSpread            Начальная ширина распыления.
* @param eSpread            Конечная ширина распыления.
* @param iSpeed              Скорость распыления.
* @param sSize                 Начальный размер материала дыма.
* @param eSize                 Конечный размер материала дыма.
* @param iRate                 Плонтость дыма(скорость появления).(чем выше, тем больше лагов)
* @param iLenght             Высота дыма.
* @param iRotate             Закрученность дыма.
* @param rgb[]                 Цвет дыма в RGB.
* @param alpha                Прозрачность дыма.
* @param fPos[3]             Позиция появления дыма.
* @param sMaterial          Материал дыма.
* @param iSmokeEntity    entity id получаемый в событии детонации дымовой гранаты(-1 если не использовать)
* @return              true;
*/
native bool SC_CreateCustomSmoke(int sSpread, int eSpread, int iSpeed, int sSize, int eSize, int iRate, int iLenght, int iRotate, char[] rgb, char[] alpha, float fPos[3], char[] sMaterial, int iSmokeEntity);

/**
 * Создаёт цветной дым.
 *
* @param iSmokeEntity    entity id получаемый в событии детонации дымовой гранаты(-1 если не использовать)
* @param rgb[3]               Цвет дыма в RGB.
* @param fPos[3]             Позиция появления дыма.
* @param iSmokeType      Тип дыма. 1 - качественный(через него не видно ничего, сильнее понижает фпс); 2 - низкокачественный дым(через него иногда можно что-то увидеть; понижает фпс меньше!!!)
* @param iSmokeSize       Размер дыма; 1 -  большой дым; 2 -  дым среднего размера; 3 - дым приближённый к стандартным размерам
* @return              true;
*/
native bool SC_CreateCustomSmoke2(int iSmokeEntity, float rgb[3], float fPos[3], int iSmokeType = 1, int iSmokeSize = 3);

/**
 * Окрашивает дым в реальном времени, созданный через SC_CreateCustomSmoke();
 *
* @param iSmokeEntity    iEntity id дыма.
* @param rgb[3                Цвет дыма в RGB.
* @param alpha[]            Прозрачность дыма..
* @return              true;
*/
native bool SC_SetSmokeColor(int iEntity, char[] rgb, char[] alpha);

native bool SC_CreateCustomSmoke3(float fPos[3], float rgb[3], int iEnt);

public SharedPlugin __pl_smokecolors= 
{
	name = "smokecolors",
	file = "smokecolors.smx",
#if defined REQUIRE_PLUGIN
	required = 1
#else
	required = 0
#endif
};

#if !defined REQUIRE_PLUGIN
public void __pl_smokecolors_SetNTVOptional()
{
	MarkNativeAsOptional("SC_CreateCustomSmoke");
	MarkNativeAsOptional("SC_CreateCustomSmoke2");
	MarkNativeAsOptional("SC_CreateCustomSmoke3");
	MarkNativeAsOptional("SC_SetSmokeColor");
}
#endif