#pragma semicolon 1
#pragma newdecls required
#pragma tabsize 0

#include <sourcemod>
#include <sdktools>

#define DEBUG 1
#define COLORED_SMOKE_PARTICLE "particles/colored_smoke.pcf"

enum struct CEffectData
{
    float m_vOrigin[3];
    float m_vStart[3];
    float m_vNormal[3];
    float m_vAngles[3];
    int m_fFlags;
    int m_nEntIndex;
    float m_flScale;
    float m_flMagnitude;
    float m_flRadius;
    int m_nAttachmentIndex;
    int m_nSurfaceProp;
    int m_nMaterial;
    int m_nDamageType;
    int m_nHitBox;
    int m_nOtherEntIndex;
    int m_nColor;
    bool m_bPositionsAreRelativeToEntity;
    int m_iEffectName;
}

public Plugin myinfo =
{
	name	= "[CORE] SmokeColors",
	version	= "1.0.2",
	author	= "Tomiks(vk.com/tomiksofficial) | Credits: iLoco#7631 && vanz666"
};

public void OnMapStart()
{
    AddFileToDownloadsTable(COLORED_SMOKE_PARTICLE);
    PrecacheGeneric(COLORED_SMOKE_PARTICLE, true);
}

public APLRes AskPluginLoad2(Handle myself, bool late, char[] error, int err_max)
{
	CreateNative("SC_CreateCustomSmoke", SC_CreateCustomSmoke);
	CreateNative("SC_CreateCustomSmoke2", SC_CreateCustomSmoke2);
	CreateNative("SC_CreateCustomSmoke3", SC_CreateCustomSmoke3);
    CreateNative("SC_SetSmokeColor", SC_SetSmokeColor);

    RegPluginLibrary("smokecolors");
	return APLRes_Success;
}

public any SC_CreateCustomSmoke(Handle plugin, int numParams)
{
    float fDetonatePos[3], lifetime;
    char SmokeMaterial[PLATFORM_MAX_PATH], rgb[32], alpha[16],
        sBaseSpread[16],
        sSpreadSpeed[16],
        sSpeed[16],
        sStartSize[16],
        sEndSize[16],
        sRate[16],
        sJetLength[16],
        sTwist[16];
    int BaseSpread = GetNativeCell(1),
        SpreadSpeed = GetNativeCell(2),
        Speed = GetNativeCell(3),
        StartSize = GetNativeCell(4),
        EndSize = GetNativeCell(5),
        Rate = GetNativeCell(6),
        JetLength = GetNativeCell(7),
        Twist = GetNativeCell(8);
    GetNativeString(9, rgb, sizeof(rgb));
    GetNativeString(10, alpha, sizeof(alpha));
    GetNativeArray(11, fDetonatePos, sizeof(fDetonatePos));
    GetNativeString(12, SmokeMaterial, sizeof(SmokeMaterial));
    lifetime = 18.01;
    int iSmokeEntity = GetNativeCell(13);

    IntToString(BaseSpread, sBaseSpread, sizeof(sBaseSpread));
    IntToString(SpreadSpeed, sSpreadSpeed, sizeof(sSpreadSpeed));
    IntToString(Speed, sSpeed, sizeof(sSpeed));
    IntToString(StartSize, sStartSize, sizeof(sStartSize));
    IntToString(EndSize, sEndSize, sizeof(sEndSize));
    IntToString(Rate, sRate, sizeof(sRate));
    IntToString(JetLength, sJetLength, sizeof(sJetLength));
    IntToString(Twist, sTwist, sizeof(sTwist));

    int iSmoke = CreateEntityByName("env_smokestack");

    DispatchKeyValue(iSmoke, "InitialState", "1");
    DispatchKeyValue(iSmoke, "BaseSpread", sBaseSpread);
    DispatchKeyValue(iSmoke, "SpreadSpeed", sSpreadSpeed);
    DispatchKeyValue(iSmoke, "Speed", sSpeed);
    DispatchKeyValue(iSmoke, "StartSize", sStartSize);
    DispatchKeyValue(iSmoke, "EndSize", sEndSize);
    DispatchKeyValue(iSmoke, "Rate", sRate);
    DispatchKeyValue(iSmoke, "JetLength", sJetLength);
    DispatchKeyValue(iSmoke, "SmokeMaterial", SmokeMaterial);
    DispatchKeyValue(iSmoke, "Twist", sTwist);
    DispatchKeyValue(iSmoke, "rendercolor", rgb);
    DispatchKeyValue(iSmoke, "renderamt", alpha);

    DispatchSpawn(iSmoke);

    TeleportEntity(iSmoke, fDetonatePos, NULL_VECTOR, NULL_VECTOR);

    if(lifetime)
    {
        char buff[64];
        FormatEx(buff, sizeof(buff), "OnUser2 !self:TurnOff::%f:1", lifetime);
        SetVariantString(buff);

        AcceptEntityInput(iSmoke, "AddOutput");
        AcceptEntityInput(iSmoke, "FireUser2");

        CreateTimer(lifetime, Timer_SmokeRemove, EntIndexToEntRef(iSmoke), TIMER_FLAG_NO_MAPCHANGE);
    }


    if(iSmokeEntity) SetEdictFlags(iSmokeEntity, GetEdictFlags(iSmokeEntity)|FL_EDICT_DONTSEND);

	return true;
}

public any SC_CreateCustomSmoke2(Handle plugin, int numParams)
{
    int iSmokeEntity = GetNativeCell(1), iSmokeType, iSmokeSize;
    float fColor[3], fPos[3];
    GetNativeArray(2, fColor, sizeof(fColor));
    GetNativeArray(3, fPos, sizeof(fPos));
    iSmokeType = GetNativeCell(4);
    iSmokeSize = GetNativeCell(5);
    fPos[2] -= 30.0;

    switch(iSmokeSize)
    {
        case 1: fPos[2] += 10.0; // большой дым
        case 2: fPos[2] -= 5.0; // средний
        case 3: fPos[2] -= 13.0; // +- стандарт
    }

    switch(iSmokeType)
    {
        case 1:
        {
            int iEnt = CreateEntityByName("env_particlesmokegrenade");
            DispatchKeyValue(iEnt, "fadescale", "100000.0");
            DispatchKeyValue(iEnt, "fademindist", "100000");
            DispatchKeyValue(iEnt, "fademaxdist", "100000");
            SetEntityFlags(iEnt, 16777216);
            DispatchSpawn(iEnt);

            TeleportEntity(iEnt, fPos, NULL_VECTOR, NULL_VECTOR);

            int iEnt2 = CreateEntityByName("env_particlesmokegrenade");
            DispatchKeyValue(iEnt2, "fadescale", "100000.0");
            DispatchKeyValue(iEnt2, "fademindist", "100000");
            DispatchKeyValue(iEnt2, "fademaxdist", "100000");
            SetEntityFlags(iEnt2, 16777216); // 642048819216384
            DispatchSpawn(iEnt2);

            TeleportEntity(iEnt2, fPos, NULL_VECTOR, NULL_VECTOR);

            SetEntProp(iEnt, Prop_Send, "m_nRenderMode", RENDER_NORMAL, 8);
            SetEntityRenderFx(iEnt, RENDERFX_NONE);
            SetEntProp(iEnt2, Prop_Send, "m_nRenderMode", RENDER_NORMAL, 8);
            SetEntityRenderFx(iEnt2, RENDERFX_NONE);

            SetEntPropVector(iEnt, Prop_Send, "m_MinColor", fColor);
            SetEntPropVector(iEnt, Prop_Send, "m_MaxColor", fColor);
            SetEntPropVector(iEnt2, Prop_Send, "m_MinColor", fColor);
            SetEntPropVector(iEnt2, Prop_Send, "m_MaxColor", fColor);

            SetEntPropFloat(iEnt, Prop_Send, "m_FadeStartTime", 18.5);
            SetEntPropFloat(iEnt, Prop_Send, "m_FadeEndTime", 21.5);
            SetEntPropFloat(iEnt2, Prop_Send, "m_FadeStartTime", 18.5);
            SetEntPropFloat(iEnt2, Prop_Send, "m_FadeEndTime", 21.5);

            SetEntProp(iEnt, Prop_Send, "m_CurrentStage", 1);
            SetEntProp(iEnt2, Prop_Send, "m_CurrentStage", 1);

            SetEntPropFloat(iEnt, Prop_Send, "m_flSpawnTime", GetEntPropFloat(iEnt, Prop_Send, "m_flSpawnTime")-1.5);
            SetEntPropFloat(iEnt2, Prop_Send, "m_flSpawnTime", GetEntPropFloat(iEnt, Prop_Send, "m_flSpawnTime")-1.5);

            if(DEBUG) PrintToConsoleAll("TYPE 1 WAS SPAWNED");
        }
        case 2:
        {
            int iEnt = CreateEntityByName("env_particlesmokegrenade");
            DispatchKeyValue(iEnt, "fadescale", "100000.0");
            DispatchKeyValue(iEnt, "fademindist", "100000");
            DispatchKeyValue(iEnt, "fademaxdist", "100000");
            SetEntityFlags(iEnt, 16777216);
            DispatchSpawn(iEnt);

            TeleportEntity(iEnt, fPos, NULL_VECTOR, NULL_VECTOR);

            SetEntProp(iEnt, Prop_Send, "m_nRenderMode", RENDER_NORMAL, 8);
            SetEntityRenderFx(iEnt, RENDERFX_NONE);

            SetEntPropVector(iEnt, Prop_Send, "m_MinColor", fColor);
            SetEntPropVector(iEnt, Prop_Send, "m_MaxColor", fColor);

            SetEntPropFloat(iEnt, Prop_Send, "m_FadeStartTime", 18.5);
            SetEntPropFloat(iEnt, Prop_Send, "m_FadeEndTime", 21.5);

            SetEntProp(iEnt, Prop_Send, "m_CurrentStage", 1);

            SetEntPropFloat(iEnt, Prop_Send, "m_flSpawnTime", GetEntPropFloat(iEnt, Prop_Send, "m_flSpawnTime")-1.5);

            if(DEBUG) PrintToConsoleAll("TYPE 2 WAS SPAWNED");
        }
    }

    if(iSmokeEntity) SetEdictFlags(iSmokeEntity, GetEdictFlags(iSmokeEntity)|FL_EDICT_DONTSEND);

    return true;
}

public any SC_SetSmokeColor(Handle plugin, int numParams)
{
    char rgb[32], alpha[16];
	int iEnt = GetNativeCell(1);
	GetNativeString(2, rgb, sizeof(rgb));
	GetNativeString(3, alpha, sizeof(alpha));

    SetVariantString(rgb);
    AcceptEntityInput(iEnt, "Color");

    SetVariantString(alpha);
    AcceptEntityInput(iEnt, "Alpha");
	return true;
}

public Action Timer_SmokeRemove(Handle timer, int iEntity)
{
	iEntity = EntRefToEntIndex(iEntity);

    if(!IsValidEntity(iEntity)) return Plugin_Stop;
	
	AcceptEntityInput(iEntity, "TurnOff");

	char buff[64];
	FormatEx(buff, sizeof(buff), "OnUser1 !self:kill::3.0:1");
	SetVariantString(buff);

	AcceptEntityInput(iEntity, "AddOutput");
	AcceptEntityInput(iEntity, "FireUser1");

	return Plugin_Stop;
}

public any SC_CreateCustomSmoke3(Handle plugin, int numParams)
{
    float fPos[3], rgb[3];
    GetNativeArray(1, fPos, sizeof(fPos));
    GetNativeArray(2, rgb, sizeof(rgb));
    int iEnt = GetNativeCell(3);
    //StopParticleEffect(0, "explosion_smokegrenade_fallback");
    SetEdictFlags(iEnt, GetEdictFlags(iEnt)|FL_EDICT_DONTSEND);
    StartSmokeEffect("explosion_smokegrenade_colored", fPos, rgb);
}

void StartSmokeEffect(const char[] smokeParticle, const float origin[3], float rgb[3])
{
    CEffectData data;
    
    data.m_vOrigin[0] = origin[0];
    data.m_vOrigin[1] = origin[1];
    data.m_vOrigin[2] = origin[2];
    
    data.m_vStart[0] = rgb[0];
    data.m_vStart[1] = rgb[1];
    data.m_vStart[2] = rgb[2];
    
    data.m_nHitBox = GetParticleSystemIndex(smokeParticle);

    DispatchEffect("ParticleEffect", data);
}

void StopParticleEffect(int entity, const char[] particleName)
{
    CEffectData data;

    data.m_nEntIndex = entity;
    data.m_nHitBox = GetParticleSystemIndex(particleName);

    DispatchEffect("ParticleEffectStop", data);
}

void DispatchEffect(const char[] effectName, CEffectData data)
{
    data.m_iEffectName = GetEffectIndex(effectName);

    TE_SetupEffectDispatch(data);
    TE_SendToAll();
}

int GetEffectIndex(const char[] effectName)
{
    static int table = INVALID_STRING_TABLE;
    
    if (table == INVALID_STRING_TABLE)
        table = FindStringTable("EffectDispatch");
    
    int index = FindStringIndex(table, effectName);
    
    if (index != INVALID_STRING_INDEX)
        return index;

    return 0;
}

int GetParticleSystemIndex(const char[] effectName)
{
    static int table = INVALID_STRING_TABLE;
    
    if (table == INVALID_STRING_TABLE)
        table = FindStringTable("ParticleEffectNames");
    
    int index = FindStringIndex(table, effectName);
    
    if (index != INVALID_STRING_INDEX)
        return index;

    return 0;
}

void TE_SetupEffectDispatch(CEffectData data)
{
    TE_Start("EffectDispatch");
    TE_WriteFloatArray("m_vOrigin.x", data.m_vOrigin, 3);
    TE_WriteFloatArray("m_vStart.x", data.m_vStart, 3);
    TE_WriteAngles("m_vAngles", {0.0, 0.0, 0.0});
    TE_WriteVector("m_vNormal", {0.0, 0.0, 0.0});
    TE_WriteNum("m_fFlags", data.m_fFlags);
    TE_WriteFloat("m_flMagnitude", data.m_flMagnitude);
    TE_WriteFloat("m_flScale", data.m_flScale);
    TE_WriteNum("m_nAttachmentIndex", data.m_nAttachmentIndex);
    TE_WriteNum("m_nSurfaceProp", data.m_nSurfaceProp);
    TE_WriteNum("m_iEffectName", data.m_iEffectName);
    TE_WriteNum("m_nMaterial", data.m_nMaterial);
    TE_WriteNum("m_nDamageType", data.m_nDamageType);
    TE_WriteNum("m_nHitBox", data.m_nHitBox);
    TE_WriteNum("entindex", data.m_nEntIndex);
    TE_WriteNum("m_nOtherEntIndex", data.m_nOtherEntIndex);
    TE_WriteNum("m_nColor", data.m_nColor);
    TE_WriteFloat("m_flRadius", data.m_flRadius);
    TE_WriteNum("m_bPositionsAreRelativeToEntity", data.m_bPositionsAreRelativeToEntity);
}